Index: src/Actions/AnalysisAction/PointCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PointCorrelationAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -15,9 +15,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::vector<const element *>)(Vector)(double)(double)(double)(std::string)(std::string)(bool)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (std::vector<const element *>)(Vector)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (elements)(Point)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("elements")("position")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("set of elements")("position in R^3 space")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
+#define paramdefaults (NODEFAULT)(NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "pair correlation analysis between element and point"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -86,7 +86,3 @@
   return true;
 }
-
-const string AnalysisPrincipalAxisSystemAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.def
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -1,3 +1,4 @@
 #undef paramdescriptions
+#undef paramdefaults
 /*
  * PrincipalAxisSystemAction.def
@@ -11,9 +12,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
@@ -25,6 +27,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "calculate the principal axis system of the specified molecule"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -55,6 +55,6 @@
 
   // execute action
-  output.open(params.outputname.c_str());
-  binoutput.open(params.binoutputname.c_str());
+  output.open(params.outputname.string().c_str());
+  binoutput.open(params.binoutputname.string().c_str());
   ASSERT(params.Boundary != NULL, "No molecule specified for SurfaceCorrelation.");
   const double radius = 4.;
@@ -114,7 +114,3 @@
   return true;
 }
-
-const string AnalysisSurfaceCorrelationAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -14,9 +14,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::vector<const element *>)(molecule *)(double)(double)(double)(std::string)(std::string)(bool)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (std::vector<const element *>)(const molecule *)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (elements)(Boundary)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("elements")("molecule-by-id")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("set of elements")("index of a molecule")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
+#define paramdefaults (NODEFAULT)(NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
@@ -28,6 +29,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "pair correlation analysis between element and surface"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/AddAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -93,7 +93,3 @@
   return true;
 }
-
-const string AtomAddAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AtomAction/AddAction.def
===================================================================
--- src/Actions/AtomAction/AddAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/AddAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -13,9 +13,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (const element *)(BoxVector)
-#define paramtokens ("add-atom")("position")
-#define paramdescriptions ("add atom of specified element")("position in R^3 space")
+#define paramtokens ("add-atom")("domain-position")
+#define paramdescriptions ("element of new atom")("position within current domain")
 #define paramreferences (elemental)(position)
+#define paramdefaults (NODEFAULT)(NODEFAULT)
 
 #define statetypes (const atomId_t)
@@ -30,6 +31,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "add atom of specified element"
 #define SHORTFORM "a"
-#define TYPEINFO &typeid(const element)
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -105,7 +105,3 @@
   return true;
 }
-
-const string AtomChangeElementAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AtomAction/ChangeElementAction.def
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/ChangeElementAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -12,8 +12,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (const element *)
 #define paramtokens ("change-element")
-#define paramdescriptions ("change the element of an atom")
+#define paramdescriptions ("new the element of atom")
+#undef paramdefaults
 #define paramreferences (elemental)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "change the element of an atom"
 #define SHORTFORM "E"
-#define TYPEINFO &typeid(const element)
Index: src/Actions/AtomAction/RemoveAction.cpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/RemoveAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -107,7 +107,3 @@
   return true;
 }
-
-const string AtomRemoveAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AtomAction/RemoveAction.def
===================================================================
--- src/Actions/AtomAction/RemoveAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/RemoveAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "remove a specified atom"
 #define SHORTFORM "r"
-#define TYPEINFO &typeid(void)
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -98,7 +98,3 @@
   return true;
 }
-
-const string AtomRotateAroundOriginByAngleAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.def
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (double)(Vector)
 #define paramtokens ("rotate-origin")("position")
-#define paramdescriptions ("rotate selected atoms by a specific angle around origin")("position in R^3 space")
+#define paramdescriptions ("rotation angle")("position in R^3 space")
+#undef paramdefaults
 #define paramreferences (angle)(Axis)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "rotate selected atoms by a specific angle around origin"
 #undef SHORTFORM
-#define TYPEINFO &typeid(double)
Index: src/Actions/AtomAction/TranslateAction.cpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/TranslateAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -88,7 +88,3 @@
   return true;
 }
-
-const string AtomTranslateAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AtomAction/TranslateAction.def
===================================================================
--- src/Actions/AtomAction/TranslateAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomAction/TranslateAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -12,9 +12,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (Vector)(bool)
 #define paramtokens ("translate-atoms")("periodic")
-#define paramdescriptions ("translate all selected atoms by given vector")("system is constraint to periodic boundary conditions")
+#define paramdescriptions ("translation vector")("system is constraint to periodic boundary conditions")
 #define paramreferences (x)(periodic)
+#define paramdefaults (NODEFAULT)("0")
 
 #define statetypes (std::vector<atom*>)
@@ -30,6 +31,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "translate all selected atoms by given vector"
 #define SHORTFORM "t"
-#define TYPEINFO &typeid(VectorValue)
Index: src/Actions/AtomsCalculation.hpp
===================================================================
--- src/Actions/AtomsCalculation.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomsCalculation.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -17,5 +17,5 @@
 {
 public:
-  AtomsCalculation(boost::function<T(atom*)> op,std::string name,AtomDescriptor descr);
+  AtomsCalculation(boost::function<T(atom*)> op,const ActionTraits &_trait,AtomDescriptor descr);
   virtual ~AtomsCalculation();
 
Index: src/Actions/AtomsCalculation_impl.hpp
===================================================================
--- src/Actions/AtomsCalculation_impl.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AtomsCalculation_impl.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -15,6 +15,6 @@
 
 template<typename T>
-AtomsCalculation<T>::AtomsCalculation(boost::function<T(atom*)> _op,std::string name,AtomDescriptor _descr) :
-  Calculation<std::vector<T> >(0,name,false),
+AtomsCalculation<T>::AtomsCalculation(boost::function<T(atom*)> _op,const ActionTraits &_trait,AtomDescriptor _descr) :
+  Calculation<std::vector<T> >(0,_trait,false),
   descr(_descr),
   op(_op)
Index: src/Actions/Calculation.hpp
===================================================================
--- src/Actions/Calculation.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Calculation.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -21,5 +21,5 @@
 {
 public:
-  Calculation(int _maxSteps, std::string _name, bool _doRegister=true);
+  Calculation(int _maxSteps, const ActionTraits &_trait, bool _doRegister=true);
   virtual ~Calculation();
 
Index: src/Actions/Calculation_impl.hpp
===================================================================
--- src/Actions/Calculation_impl.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Calculation_impl.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -14,6 +14,6 @@
 
 template<typename T>
-Calculation<T>::Calculation(int _maxSteps, std::string _name, bool _doRegister) :
-  Process(_maxSteps,_name,_doRegister),
+Calculation<T>::Calculation(int _maxSteps, const ActionTraits &_trait, bool _doRegister) :
+  Process(_maxSteps,_trait,_doRegister),
   result(0),
   done(false)
Index: src/Actions/CommandAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/BondLengthTableAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -47,5 +47,5 @@
   if (configuration->BG == NULL) {
     configuration->BG = new BondGraph(configuration->GetIsAngstroem());
-    if ((!params.BondGraphFileName.empty()) && (configuration->BG->LoadBondLengthTable(params.BondGraphFileName))) {
+    if ((!params.BondGraphFileName.empty()) && (configuration->BG->LoadBondLengthTable(params.BondGraphFileName.string()))) {
       DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
       return Action::success;
@@ -81,7 +81,3 @@
   return false;
 }
-
-const string CommandBondLengthTableAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/BondLengthTableAction.def
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/BondLengthTableAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
 #define paramtokens ("bond-table")
-#define paramdescriptions ("setting name of the bond length table file")
+#define paramdescriptions ("name of the bond length table file")
+#undef paramdefaults
 #define paramreferences (BondGraphFileName)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
-#define DESCRIPTION "setting name of the bond length table file"
+#define DESCRIPTION "specifying a table file with specific bond lengths to use in bond structure analysis"
 #define SHORTFORM "g"
-#define TYPEINFO &typeid(std::string)
Index: src/Actions/CommandAction/ElementDbAction.cpp
===================================================================
--- src/Actions/CommandAction/ElementDbAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/ElementDbAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -46,5 +46,5 @@
   // TODO: Make databasepath a std::string
   config *configuration = World::getInstance().getConfig();
-  strcpy(configuration->databasepath, params.databasepath.c_str());
+  strcpy(configuration->databasepath, params.databasepath.branch_path().string().c_str());
 
   // load table
@@ -82,7 +82,3 @@
   return false;
 }
-
-const string CommandElementDbAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/ElementDbAction.def
===================================================================
--- src/Actions/CommandAction/ElementDbAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/ElementDbAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
 #define paramtokens ("element-db")
-#define paramdescriptions ("setting the path where the element databases can be found")
+#define paramdescriptions ("path where the element databases can be found")
+#undef paramdefaults
 #define paramreferences (databasepath)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
-#define DESCRIPTION "setting the path where the element databases can be found"
+#define DESCRIPTION "specify the path to a different element databases"
 #define SHORTFORM "e"
-#define TYPEINFO &typeid(std::string)
Index: src/Actions/CommandAction/FastParsingAction.cpp
===================================================================
--- src/Actions/CommandAction/FastParsingAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/FastParsingAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -84,7 +84,3 @@
   return true;
 }
-
-const string CommandFastParsingAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/FastParsingAction.def
===================================================================
--- src/Actions/CommandAction/FastParsingAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/FastParsingAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (bool)
 #define paramtokens ("fastparsing")
 #define paramdescriptions ("setting whether trajectories shall be parsed completely (n) or just first step (y)")
+#undef paramdefaults
 #define paramreferences (fastparsing)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#define DEFAULTVALUE "0"
 #define DESCRIPTION "setting whether trajectories shall be parsed completely (n) or just first step (y)"
 #define SHORTFORM "n"
-#define TYPEINFO &typeid(bool)
Index: src/Actions/CommandAction/HelpAction.cpp
===================================================================
--- src/Actions/CommandAction/HelpAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/HelpAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -19,6 +19,4 @@
 
 #include "Helpers/MemDebug.hpp"
-
-#include "CommandLineParser.hpp"
 
 #include <iostream>
@@ -55,7 +53,3 @@
   return false;
 }
-
-const string CommandHelpAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/HelpAction.def
===================================================================
--- src/Actions/CommandAction/HelpAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/HelpAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "help screen"
 #define SHORTFORM "h"
-#define TYPEINFO &typeid(void)
Index: src/Actions/CommandAction/VerboseAction.cpp
===================================================================
--- src/Actions/CommandAction/VerboseAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/VerboseAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -76,7 +76,3 @@
   return true;
 }
-
-const string CommandVerboseAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/VerboseAction.def
===================================================================
--- src/Actions/CommandAction/VerboseAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/VerboseAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (int)
 #define paramtokens ("verbose")
 #define paramdescriptions ("set verbosity level")
+#undef paramdefaults
 #define paramreferences (verbosity)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "set verbosity level"
 #define SHORTFORM "v"
-#define TYPEINFO &typeid(int)
Index: src/Actions/CommandAction/VersionAction.cpp
===================================================================
--- src/Actions/CommandAction/VersionAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/VersionAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -55,7 +55,3 @@
   return false;
 }
-
-const string CommandVersionAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/VersionAction.def
===================================================================
--- src/Actions/CommandAction/VersionAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/VersionAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "show version"
 #define SHORTFORM "V"
-#define TYPEINFO &typeid(void)
Index: src/Actions/CommandAction/WarrantyAction.cpp
===================================================================
--- src/Actions/CommandAction/WarrantyAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/WarrantyAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -19,6 +19,4 @@
 
 #include "Helpers/MemDebug.hpp"
-
-#include "CommandLineParser.hpp"
 
 #include <iostream>
@@ -61,7 +59,3 @@
   return false;
 }
-
-const string CommandWarrantyAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/CommandAction/WarrantyAction.def
===================================================================
--- src/Actions/CommandAction/WarrantyAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/CommandAction/WarrantyAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -10,8 +10,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -28,6 +29,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "statement concerning warranty of the software"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/ErrorAction.cpp
===================================================================
--- src/Actions/ErrorAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ErrorAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -29,6 +29,6 @@
 using namespace std;
 
-ErrorAction::ErrorAction(string _name,const char * _errorMsg,bool _doRegister) :
-Action(_name,_doRegister),
+ErrorAction::ErrorAction(const ActionTraits &_trait,const char * _errorMsg,bool _doRegister) :
+Action(_trait,_doRegister),
 errorMsg(_errorMsg)
 {
Index: src/Actions/ErrorAction.hpp
===================================================================
--- src/Actions/ErrorAction.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ErrorAction.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -15,5 +15,5 @@
 {
 public:
-  ErrorAction(std::string _name,const char * _errorMsg,bool _doRegister=true);
+  ErrorAction(const ActionTraits &_trait,const char * _errorMsg,bool _doRegister=true);
   virtual ~ErrorAction();
 
Index: src/Actions/FragmentationAction/ConstructBondGraphAction.cpp
===================================================================
--- src/Actions/FragmentationAction/ConstructBondGraphAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/FragmentationAction/ConstructBondGraphAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -174,7 +174,3 @@
   return false;
 }
-
-const string FragmentationConstructBondGraphAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/FragmentationAction/ConstructBondGraphAction.def
===================================================================
--- src/Actions/FragmentationAction/ConstructBondGraphAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/FragmentationAction/ConstructBondGraphAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "construct the bond graph of the selected atoms"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
